
/*  @(#)comliste.c 1.2 95/07/07
 *
 *  Copyright (c) Mikael Cam.
 *                All rights reserved.
 *
 *  Permission is given to distribute these sources, as long as the
 *  copyright messages are not removed, and no monies are exchanged.
 *
 *  No responsibility is taken for any errors inherent either
 *  to the comments or the code of this program, but if reported
 *  to me then an attempt will be made to fix them.
 */

/*  
 * Module               : comliste.c   
 * Auteur               : Mikael CAM 
 * Cadre                : Projet Mimep  
 * Derniere M.A.J.      : 
 * 
 * Version              : OK 
 *  
 * Objet                : Gestion de la liste des dernieres commandes  
 *                        de texte enrichi. 
 * 
 *             
 */  
 
  
 

#include "comliste.h" 
#define  TRUE      1
#define  FALSE     0
#define  _TRACE    0

 
 
 


/* 
 * $PROCEDURE   CreeListe: Creation de la liste des commandes.     */ 
 
void CreeListe (Liste_com *l) 
 
/* 
 *       
 *      Retour : rien.              
 *              OK      :  fonctionnement correct 
 *              NOK     : 
 * 
 * $PROCEDURE 
 * 
 * $IMPLEMENTATION 
        <description des particularites d'implementation> 
 * $IMPLEMENTATION 
 */ 
{ 
        /* 
         *      Variables locales a la procedure 
         */ 
 
        /* 
         *      Code de la procedure 
         */ 
 
        l->courant      = NULL; 
        l->tete         = NULL; 
        l->queue        = NULL; 
 
 
} 
 
 
 
/* 
 * $FIN_PROCEDURE       CreeListe               
 */ 
 
 
/*  
 * $PROCEDURE           suivant: Positionnement sur le suivant dans la liste.                                          
 */ 
 
format_com *suivant (Liste_com *l) 
 
/* 
 *       
 *      Retour :               
 *              OK      :  fonctionnement correct 
 *              NOK     : 
 * 
 * $PROCEDURE 
 * 
 * $IMPLEMENTATION 
        <description des particularites d'implementation> 
 * $IMPLEMENTATION 
 */ 
{ 
        /* 
         *      Variables locales a la procedure 
         */ 
 
        /* 
         *      Code de la procedure 
         */ 
         
        if (l->courant != l->queue) 
        l->courant = l->courant->suivant; 
        return (l->courant); 
} 
 
 
 
 
/* 
 * $FIN_PROCEDURE       suivant               
 */ 
  
 
/* 
 * $PROCEDURE           courant: Renvoie un pointeur sur l'element courant.                            
 */ 
 
 
format_com *courant (Liste_com *l) 
 
 
 
/* 
 *       
 *      Retour :               
 *              OK      :  fonctionnement correct 
 *              NOK     : 
 * 
 * $PROCEDURE 
 * 
 * $IMPLEMENTATION 
        <description des particularites d'implementation> 
 * $IMPLEMENTATION 
 */ 
{ 
        /* 
         *      Variables locales a la procedure 
         */ 
         
        /* 
         *      Code de la procedure 
         */ 
         
        return (l->courant); 
} 
 
 
 
 
/* 
 * $FIN_PROCEDURE               courant              
 */ 
 
 
/* 
 * $PROCEDURE           position_tete: Positionnement sur la tete de liste.                                    
 */ 
 
 
format_com *position_tete (Liste_com *l) 
 
 
 
/* 
 *       
 *      Retour :               
 *              OK      :  fonctionnement correct 
 *              NOK     : 
 * 
 * $PROCEDURE 
 * 
 * $IMPLEMENTATION 
        <description des particularites d'implementation> 
 * $IMPLEMENTATION 
 */ 
{ 
        /* 
         *      Variables locales a la procedure 
         */ 
 
        /* 
         *      Code de la procedure 
         */ 
         
         
        l->courant = l->tete;  
        return (l->tete); 
 
} 
 
 
 
 
/* 
 * $FIN_PROCEDURE              position_tete 
 */ 
 
 
/* 
 * $PROCEDURE           AjouteListe: Ajout d'un element dans la liste.                                   
 */ 
 
void AjouteListe (Liste_com *l, format_com *p ) 
 
/* 
 *       
 *      Retour :               
 *              OK      :  fonctionnement correct 
 *              NOK     : 
 * 
 * $PROCEDURE 
 * 
 * $IMPLEMENTATION 
        <description des particularites d'implementation> 
 * $IMPLEMENTATION 
 */ 
{ 
        /*                       
         *      Variables locales a la procedure 
         */ 
         
        /* 
         *      Code de la procedure 
         */ 
         
        if ( l->tete == NULL) { 
                        l->tete = p; 
                        l->queue = p; 
                        l->courant = p; 
                        } 
 
        l->queue->suivant = p; 
        p->precedent = l->queue; 
        l->queue = p; 
}  
 
 
 
 
/* 
 * $FIN_PROCEDURE               AjouteListe               
 */ 
 
 

 
/* 
 * $PROCEDURE           OteEltListe: Ote un element dans la liste.                                  
 */ 
 
void OteEltListe (Liste_com *l, format_com *p) 
 
 
 
 
/* 
 *       
 *      Retour :               
 *              OK      :  fonctionnement correct 
 *              NOK     : 
 * 
 * $PROCEDURE 
 * 
 * $IMPLEMENTATION 
        <description des particularites d'implementation> 
 * $IMPLEMENTATION 
 */ 
{ 
        /* 
         *      Variables locales a la procedure 
         */ 
         
        /* 
         *      Code de la procedure 
         */ 
 
        if ( ( p != l->tete) && (p != l->queue)) 
                { 
                p->precedent->suivant = p->suivant; 
                p->suivant->precedent = p->precedent; 
                free(p); 
                } 
        else if ( (p == l->queue) && (p != l->tete) ) 
                { 
                p->precedent->suivant = NULL; 
                l->queue = p->precedent; 
                free(p); 
                }        
        else if ( (p == l->tete ) && (p != l->queue) ) 
                { 
                p->suivant->precedent = NULL; 
                l->tete = p->suivant; 
                free(p); 
                } 
        else    { 
                l->tete = NULL; 
                l->queue = NULL; 
                l->courant = NULL; 
                /* free(p); */  
                } 
} 
 
 
 
/* 
 * $FIN_PROCEDURE               OteEltListe               
 */ 
 
 
 
/* 
 * $PROCEDURE           FinListe: Verifie si l'on est en fin de liste.                                
 */ 
 
int     FinListe (Liste_com *l) 
 
 
 
 
/* 
 *       
 *      Retour :               
 *              OK      :  fonctionnement correct 
 *              NOK     : 
 * 
 * $PROCEDURE 
 * 
 * $IMPLEMENTATION 
        <description des particularites d'implementation> 
 * $IMPLEMENTATION 
 */ 
{ 
        /* 
         *      Variables locales a la procedure 
         */ 
 
        /* 
         *      Code de la procedure 
         */ 
         
        if (l->courant == l->queue) return (TRUE); 
        else return (FALSE); 
} 
 
 
 
 
/* 
 * $FIN_PROCEDURE               FinListe               
 */ 
 
 
 
/* 
 * $PROCEDURE           remplie_param: Remplie les parametres d'un element de la liste.                             
 */ 
 
 
void remplie_comm (format_com *p, Command c, Liste_com *l) 
 
 
 
 
/* 
 *       
 *      Retour :               
 *              OK      :  fonctionnement correct 
 *              NOK     : 
 * 
 * $PROCEDURE 
 * 
 * $IMPLEMENTATION 
        <description des particularites d'implementation> 
 * $IMPLEMENTATION 
 */ 
{ 
        /* 
         *      Variables locales a la procedure 
         */ 
 
        /* 
         *      Code de la procedure 
         */ 
        Command commande;
	commande = (Command) malloc ((sizeof(char)) * strlen(c));
	strcpy(commande, c);
        p->c_name = commande; 
} 
 
 
 
/* 
 * $FIN_PROCEDURE               remplie_param               
 */ 
 
 
/* 
 * $PROCEDURE           Trouve: essaie de trouver un element donne de la liste                                
 *                              correspondant a la fenetre passee en parametres. 
 */ 
 
 
format_com *Trouve(Command c, Liste_com *l) 
 
 
 
/* 
 *       
 *      Retour :               
 *              OK      :  fonctionnement correct 
 *              NOK     : 
 * 
 * $PROCEDURE 
 * 
 * $IMPLEMENTATION 
        <description des particularites d'implementation> 
 * $IMPLEMENTATION 
 */ 
{ 
        /* 
         *      Variables locales a la procedure 
         */ 
         
 
        format_com *cp_cour;      
        int       existe; 
 
 
 
 
        /* 
         *      Code de la procedure 
         */ 
 
 
                /* Recherche des derniers parametres de la fenetre concernee */ 
	if(_TRACE) printf (" Recherche \n");
        existe = FALSE; 
 
        cp_cour = position_tete (l); 
         
 
	
        if ((cp_cour) && (!strcmp(cp_cour->c_name, c))) existe = TRUE; 
        else { 
         
        while ( (!FinListe (l)) && (!existe))   { 
                         
                        cp_cour = suivant(l); 
                         

			if (!strcmp(cp_cour->c_name, c)) existe = TRUE;
                                                 
                        if(_TRACE) printf (" Recherche: Command: %s\n", cp_cour->c_name); 
                        
                                     
                                                }                
              }  
 
        if (existe) return(cp_cour);  
        else return (NULL); 
} 
 
 
 
/* 
 * $FIN_PROCEDURE               Trouve               
 */ 
